#include "common.h"
#include "dnautil.h"
#include "dnaseq.h"
#include "sig.h"
#include "fa.h"

void writeToNib(struct dnaSeq *seq, char *fileName)
/* Write out file in format of four bits per nucleotide. */
{
int i;
UBYTE byte;
DNA *dna = seq->dna;
int dVal;
bits32 size = seq->size;
int byteCount = (size>>1);
bits32 sig = nibSig;
int nCount = 0;
FILE *f = mustOpen(fileName, "w");

assert(sizeof(bits32) == 4);

writeOne(f, sig);
writeOne(f, seq->size);

printf("Writing %d bases in %d bytes\n", seq->size, ((seq->size+1)/2) + 8);
while (--byteCount >= 0)
    {
    dVal = ntVal5[dna[0]];
    byte = (dVal<<4);
    dVal = ntVal5[dna[1]];
    byte |= dVal;
    if (putc(byte, f) < 0)
	{
	perror("");
	errAbort("Couldn't write all of %s", fileName);
	}
    dna += 2;
    }
if (size & 1)
    {
    dVal = ntVal5[dna[0]];
    byte = (dVal<<4);
    putc(byte, f);
    }
}

int main(int argc, char *argv[])
{
char *inName, *outName;
struct dnaSeq *seq;
FILE *outFile;

if (argc != 3)
    {
    errAbort("faToNib - a program to convert .fa files to .nib files\n"
             "Usage: faToNib in.fa out.nib");
    }
dnaUtilOpen();
inName = argv[1];
outName = argv[2];
seq = faReadDna(inName);
writeToNib(seq, outName);
return 0;
}
